<?php

function new_token() {
	return md5 ( uniqid ( microtime () ) . time () );
}

function cryptIT($val) {
	return hash('sha256', md5($val));
}

function setToken($permissions,$fee_obj=false) {
	$token = new_token();
	if (isset($_SERVER["HTTP_CF_CONNECTING_IP"])) {
	  $_SERVER['REMOTE_ADDR'] = $_SERVER["HTTP_CF_CONNECTING_IP"];
	}
	$a = array('token'=>$token,'exp_time'=>time()+_DEFAULT_EXP_TIME,'permissions'=>$permissions,'IP'=>$_SERVER['REMOTE_ADDR']);
	if ($fee_obj) $a['fee_obj'] = $fee_obj;
	add_obj('tokens',$a);
	return $token;
}
/**
PERMISSIONS structure
array("method_name"=>'all',
	"method_name"=>array("required_parameters"=>'all',"allow_parameters"=>array("param_name"=>array("param_value",..),"param_name"=>'all',..),
	...
	);
**/
$_TOKEN_OBJ = '';
function check_permissions($param) {
	global $_TOKEN_OBJ; 
	if (!isset($param['method'])) return array('error'=>'method missing');
	if (initialCheckPermitions(@$param['method'],@$param['token'],$param)) return true;
	if (isset($param['token']) ) $token_obj = getResult(get_obj('tokens',array('token'=>$param['token'])));
	else return array('error'=>'empty token');
	$_TOKEN_OBJ = $token_obj;
	if (empty($token_obj)) return array('error'=>'token invalid');
	if ($token_obj[0]['exp_time']<time()) {
		return array('error'=>'token expired');
	}
	
	if (!isset($token_obj[0]['permissions'][$param['method']])) {
		return array('error'=>'permissions error');
	} else {
		if (isset($token_obj[0]['permissions'][$param['method']]['required_param'])) {
			foreach($token_obj[0]['permissions'][$param['method']]['required_param'] as $param_name => $param_value) {
				if ( !isset($param[$param_name]) || $param[$param_name] != $param_value) {
					return array('error'=>'permissions error');
				}
			}
		}
	}
	
	return true;
}

//=================== ip protection ==============
function ip_protection_set($method) {
	$param = array();
	$param['method'] = $method;
	if (isset($_SERVER["HTTP_CF_CONNECTING_IP"])) {
	  $_SERVER['REMOTE_ADDR'] = $_SERVER["HTTP_CF_CONNECTING_IP"];
	}
	$param['ip'] = $_SERVER['REMOTE_ADDR'];
	$param['request'] = $_REQUEST;
	add_obj('ip_protection_log',$param);
}

function ip_protection_get($method,$interval=3600) {
	$param = array();
	$param['method'] = $method;
	if (isset($_SERVER["HTTP_CF_CONNECTING_IP"])) {
	  $_SERVER['REMOTE_ADDR'] = $_SERVER["HTTP_CF_CONNECTING_IP"];
	}
	$param['ip'] = $_SERVER['REMOTE_ADDR'];
	$param['cr_time'] = array('$gte'=>(time() - $interval));
	return getResult(get_obj('ip_protection_log',$param));
}

function ip_protection_check($method,$interval=3600,$call_limit=3) {
	$res = ip_protection_get($method);
	$count = count($res);
	if ( $count <= ($call_limit+1) ) { ;
		return true;
	}
	else {
		return false;
	}
}

function ip_protection($method,$interval=3600,$call_limit=3) {
	$res = ip_protection_get($method);
	$count = count($res)+1;
	if ( $count <= ($call_limit+1) ) { ;
		ip_protection_set($method);
		return $count;
	}
	else {
		return false;
	}
}
//=================== / ip protection ==============

function add_obj($collection_name,$_PARMAS=false) {
	global $db;
	if (!$_PARMAS) $_PARMAS = $_REQUEST;
	$collection = $db->$collection_name;
	$obj = Array();
	foreach ($_PARMAS as $k => $val) {
		if ($k == 'pass') $val = cryptIT($val); 
		$obj[$k] = $val;
	}
	if (!isset($obj['cr_time'])) $obj['cr_time'] = time();
	if (!isset($obj['internal_id'])) $obj['internal_id'] = uniqid();
	$collection->insert($obj);
	return $obj;
}


function get_one_obj($collection_name,$_PARMAS=false) {
	global $db;
	if ($_PARMAS===false) $_PARMAS = $_REQUEST;
	unset($_PARMAS["method"]);
	if ($collection_name != 'tokens') unset($_PARMAS["token"]);
	unset($_PARMAS["callback_function"]);
	unset($_PARMAS["callback_param"]);
	$collection = $db->$collection_name;
	$param = Array();
	foreach ($_PARMAS as $k => $val) {
		if ($k == 'pass') $val = cryptIT($val);
		if ($k == '_id') $val = new MongoId($val);
		$param[$k] = $val;
	}
	//$cursor = $collection->findOne($param);
	$cursor = $collection->find($param);
	$cursor = $cursor->sort(array('cr_time'=>-1));
	$cursor = $cursor->limit(1);
	return $cursor;
}

function get_obj($collection_name,$_PARMAS=false) {
	global $db;
	if ($_PARMAS===false) $_PARMAS = $_REQUEST;
	unset($_PARMAS["method"]);
	//unset($_PARMAS["collection"]);
	if ($collection_name != 'tokens') unset($_PARMAS["token"]);
	unset($_PARMAS["callback_function"]);
	unset($_PARMAS["callback_param"]);
	$limit = $skip = false;
	if (isset($_PARMAS["limit"])) {
		$limit = (int)$_PARMAS["limit"];
		unset($_PARMAS["limit"]);
	}
	if (isset($_PARMAS["skip"])) {
		$skip = (int)$_PARMAS["skip"];
		unset($_PARMAS["skip"]);
	}
	$collection = $db->$collection_name;
	$param = Array();
	foreach ($_PARMAS as $k => $val) {
		if ($k == 'pass') $val = cryptIT($val);
		if ($k == '_id') $val = new MongoId($val);
		$param[$k] = $val;
	}
	add_obj('logDebugCore',array('sparam'=>json_encode($param)));
// echo json_encode($param);
	$cursor = $collection->find($param);
	if ($limit) $cursor = $cursor->limit($limit);
	if ($skip) $cursor = $cursor->skip($skip);
	return $cursor;
}

function update_obj($collection_name,$_PARMAS=false) {
	global $db;
	$cursor = array();
	if ($_PARMAS===false) $_PARMAS = $_REQUEST;
	// new st
	foreach ($_PARMAS as $k => $val) {
		if ($k!='criteria'){
			if ($k == 'pass') $_PARMAS[$k] = cryptIT($val);
			if ($k == '_id') $_PARMAS[$k] = new MongoId($val);
		}
	}
	// ne st
	$collection = $db->$collection_name;
	if (isset($_PARMAS['push'])) {
		$cursor = $collection->update($_PARMAS['criteria'],array('$push'=>$_PARMAS['push']),array("upsert" => true));
	}	
	if (isset($_PARMAS['set'])) {
		$cursor = $collection->update($_PARMAS['criteria'],array('$set'=>$_PARMAS['set']),array('multiple' => true));
	}	
	if (isset($_PARMAS['Wset'])) {
		$cursor = $collection->update($_PARMAS['criteria'],array('$set'=>$_PARMAS['Wset']),array("w" => "AllDCs"));
	}
	if (isset($_PARMAS['upsert'])) {
		$cursor = $collection->update($_PARMAS['criteria'],array('$set'=>$_PARMAS['upsert']),array("upsert" => true));
	}		
	if (isset($_PARMAS['inc'])) {
		$cursor = $collection->update($_PARMAS['criteria'],array('$inc'=>$_PARMAS['inc']));
	}	
	if (isset($_PARMAS['fullupdate'])) {
		$cursor = $collection->update($_PARMAS['criteria'],$_PARMAS['fullupdate']);
	}
	return $cursor;
}

function remove_obj($collection_name,$_PARMAS=false) {
	global $db;
	$cursor = array();
	if ($_PARMAS===false) $_PARMAS = $_REQUEST;
	// new st
	foreach ($_PARMAS as $k => $val) {
		if ($k!='criteria'){
			if ($k == 'pass') $_PARMAS[$k] = cryptIT($val);
			if ($k == '_id') $_PARMAS[$k] = new MongoId($val);
		}
	}
	// ne st
	$collection = $db->$collection_name;
	$cursor = $collection->remove($_PARMAS['criteria']);
	return $cursor;
}	
	
function validate($param,$filter,$type='required') {
	global $__ALLOW_COINS;
	$valid_param = array();
	$res = true;
	foreach($param as $k=>$p) {
		if (isset($filter[$k])){
			switch ($filter[$k]) {
				case 'int' : {
					$valid_param[$k] = (int)$p;
					break;
				}
			
				case 'float' : {
					$valid_param[$k] = round($p,8);
					break;
				}
			
				case 'string' : {
					$valid_param[$k] = (string)$p;
					break;
				}				
				
				case 'not_empty_string' : {
				    $ps = (string)$p;
					if (!empty( $ps )){ 
					    $valid_param[$k] = (string)$p;
					}
					else{
					    $res = false;
					}
					break;
				}
				
				case 'float>0' : {
					$p = round($p,8);
					if ($p>0) $valid_param[$k] = $p;
					else $res = false;
					break;
				}	
				
				case 'float>min_amount' : {
					$p = round($p,8);
					if ($p>=_MIN_AMOUNT_) $valid_param[$k] = $p;
					else $res = false;
					break;
				}
				
				case 'in_coins' : {
					if ($__ALLOW_COINS == 'ALL') $valid_param[$k] = $p;
					else {
						$res = in_array(strtolower($p),$__ALLOW_COINS);
						if ($res) $valid_param[$k] = $p;
					}
					break;
				}				
			}
		}	
	}
	if ($type == 'required' && count($valid_param) != count($filter) ) return false; 
	if ($type != 'required'   )  $valid_param = array_replace($param,$valid_param);
	if ($res) return $valid_param;
	else return $res;
}

//===========================================================
function getResult($cursor,$view_fields_permitions='ALL',$view_fields_type='include') {
	$res = array ();
	$res_obg = new stdClass();
	if($cursor) {
		foreach ( $cursor as $obj ) {
			if ($view_fields_permitions=='ALL') {
				$res_obg = $obj;
			}
			else {
				if ($view_fields_type=='include') {
					$res_fields = array();
					foreach ($view_fields_permitions as $field) {
						
						if (isset($obj[$field])) $res_fields[$field] = $obj[$field];
					}
					$res_obg = $res_fields;
				}
				elseif($view_fields_type=='exclude') {
					$res_obg = $obj;
					foreach ($view_fields_permitions as $field) {
						unset($res_obg[$field]);
					}					
				}
			}
			$res [] = $res_obg;
		} 
	}
	return $res;
}

function sendResult($cursor,$the_callback_function,$view_fields_permitions='ALL',$the_callback_param='',$view_fields_type='include') {
	global $m;
	$res = array ();
	$res_obg = new stdClass();
	$res = (is_array($cursor)) ? $cursor : getResult($cursor,$view_fields_permitions,$view_fields_type);
	$m->close ();
	$json_res = json_encode ( $res );
	$json_res = addslashes ( $json_res );
	
	$callback_param = ($the_callback_param) ? ",'".$the_callback_param."'" : ''; 
	
	if ( $the_callback_function ) {
		header('Content-Type: application/javascript');
		return htmlspecialchars ( $the_callback_function ) . "('{$json_res}'".$callback_param.")";
	} else{
		header('Content-type: application/json');
		return json_encode ( $res );
	}
}

//====================================================

function jsonBody2request() {
	$jsonStr = file_get_contents('php://input');
	$vars = json_decode($jsonStr,true);
	if (is_array($vars)) {
		foreach ($vars as $k=>$v) {
			$_REQUEST[$k] = $v;
		}
	}
}
