<?php
error_reporting(E_ALL);
ini_set("display_errors", 1); 
set_error_handler('logError',E_ALL|E_STRICT);
function logError($errno, $errstr, $errfile, $errline) {
	add_obj('log_error',array($errno, $errstr, $errfile, $errline));
}

include 'settings.php';
include 'core_functions.php';
include 'functions.php';

$inutstr = file_get_contents("php://input");
$_HEADERS = getallheaders();
add_obj('logDebug7',array('req'=>$_REQUEST,'HEADERS'=>$_HEADERS,'input'=>$inutstr));

/** ==== **/
add_obj('logDebug2',array('req'=>$_REQUEST,'input'=>$inutstr,'post'=>$_POST));
if ($api_request_type == 'postJsonInBody') {
	jsonBody2request();
}
$token_permitions = check_permissions($_REQUEST);
/** ===== **/

if ( $token_permitions === false  ) die('permissions error');
if (is_array($token_permitions)) { 
	$callback_param = isset($_GET ['callback_param']) ? $_GET ['callback_param'] : false ;
	$callback = isset($_GET ['callback_function']) ? $_GET ['callback_function'] : false ;
	echo sendResult($token_permitions,$callback);  die(); 
} 

$cursor = array();
switch ($_REQUEST['method']) {
//============= === ================
	case 'test_api': {
		$sanitize  = array();
		if (isset($_REQUEST['my_message']) ) $sanitize['my_message'] = 'not_empty_string';
		$param = validate($_REQUEST,$sanitize);	
		if ($param === false) { $cursor=array('error' => 'error', 'error_message' => 'invalid parameters'); break; }
		$cursor = array();
		$cursor['cr_time'] = time();		
		$cursor['message'] = 'hi Ben!!!';		
		$cursor['your_message'] = @$param['my_message'];		
		break;
	}
	case 'save_data': {
		$sanitize  = array();
		$sanitize['collection'] = 'not_empty_string';
		$param = validate($_REQUEST,$sanitize);	
		if ($param === false) { $cursor=array('error' => 'error', 'error_message' => 'invalid parameters'); break; }		
		$cursor['result'] = add_obj($_REQUEST['collection'],$_REQUEST);
		break;
	}
	case 'get_data': {
		$sanitize  = array();
		$sanitize['collection'] = 'not_empty_string';
		$param = validate($_REQUEST,$sanitize);	
		if ($param === false) { $cursor=array('error' => 'error', 'error_message' => 'invalid parameters'); break; }
		$cursor['result'] = getResult(get_obj($_REQUEST['collection'],$_REQUEST));
		break;
	}
	case 'delete_data': {
		$sanitize  = array();
		$sanitize['collection'] = 'not_empty_string';
		$sanitize['internal_id'] = 'not_empty_string';
		$param = validate($_REQUEST,$sanitize);	
		if ($param === false) { $cursor=array('error' => 'error', 'error_message' => 'invalid parameters'); break; }
		$cursor['result'] = remove_obj($_REQUEST['collection'],array('criteria'=>array('internal_id'=>$param['internal_id'])));
		break;
	}
	case 'clear_collection' : {
			$collection = $db->$_REQUEST['collection'];
			$cursor['result'] = $collection->drop();
			break;
	}
	case 'update_data': {
		$sanitize  = array();
		$sanitize['collection'] = 'not_empty_string';
		$sanitize['internal_id'] = 'not_empty_string';
		$param = validate($_REQUEST,$sanitize);	
		if ($param === false) { $cursor=array('error' => 'error', 'error_message' => 'invalid parameters'); break; }
		$cursor['result'] = update_obj($_REQUEST['collection'],array('criteria'=>array('internal_id'=>$param['internal_id']),'set'=>$_REQUEST));
		break;
	}
//===================================================
	case 'register_user': {
		$sanitize  = array();
		$sanitize['email'] = 'not_empty_string';
		$sanitize['pass'] = 'not_empty_string';
		if (isset($_REQUEST['deviceToken'])) $sanitize['deviceToken'] = 'not_empty_string';
		if (isset($_REQUEST['fbid'])) $sanitize['fbid'] = 'not_empty_string';
		if (isset($_REQUEST['name'])) $sanitize['name'] = 'not_empty_string';
		// var_dump($_REQUEST);
		$param = validate($_REQUEST,$sanitize);
		if ($param === false) { $cursor=array('error' => 'error', 'error_message' => 'invalid parameters'); break; }
	
		$uemail = getResult( get_obj('users',array('email'=>$param['email'])) );

		if (empty($user) && empty($uemail)) {
			$cursor = array();
			$cursor['data'] = add_obj('users',$param);
			$cursor = array();
			$cursor = login_user($param);
			if (isset($cursor['error'])) {
				break;
			}
			if (isset($cursor ["result"][0]['role']) && $cursor ["result"][0]['role'] == 'admin') $permissions = setAdmPerm($cursor);
			elseif (isset($cursor ["result"][0]['role']) && $cursor ["result"][0]['role'] == 'super_admin') $permissions = setSuperAdmPerm($cursor);
			else	$permissions = setUserPerm($cursor);
			if (!isset($_REQUEST['deviceToken']))  $_REQUEST['deviceToken'] = '';
			$cursor['token'] = setToken($permissions,array('device_token'=>$_REQUEST['deviceToken'],'user_name'=>$_REQUEST['name']));
			$cursor['ltime'] = time();	
		} 
		else {
			$cursor = array();
			$cursor['error'] = 'User already register.';
		}	
		break;
	}
	
	case 'login_user': {
		$sanitize  = array();
		$sanitize['email'] = 'not_empty_string';
		$sanitize['pass'] = 'not_empty_string';
		$param = validate($_REQUEST,$sanitize);	
		if ($param === false) { $cursor=array('error' => 'error', 'error_message' => 'invalid parameters'); break; }
		// $view_fields_permitions = array('login','fullname','internal_id','email','fbui','fee_obj');
		$param['email'] =trim($param['email']);
		$cursor = array();
		$cursor = login_user($param);
		if (isset($cursor['error'])) {
			break;
		}
		if (isset($cursor ["result"][0]['role']) && $cursor ["result"][0]['role'] == 'admin') $permissions = setAdmPerm($cursor);
		elseif (isset($cursor ["result"][0]['role']) && $cursor ["result"][0]['role'] == 'super_admin') $permissions = setSuperAdmPerm($cursor);
		else	$permissions = setUserPerm($cursor);
		if (!isset($_REQUEST['deviceToken']))  $_REQUEST['deviceToken'] = '';
		$cursor['token'] = setToken($permissions,array('device_token'=>$_REQUEST['deviceToken'],'user_name'=>$_REQUEST['name']));
		$cursor['ltime'] = time();	
		if (isset($_REQUEST['deviceToken'])) update_last_login_time($cursor ["result"][0]['internal_id'],$_REQUEST['deviceToken']) ;
		break;
	}	
//===================================================
	default : {
		$cursor['error'] = 'No method name';
	}
}

$view_fields_permitions = isset($view_fields_permitions) ? $view_fields_permitions : 'ALL';
$view_fields_type = isset($view_fields_type) ? $view_fields_type : 'include';
$callback_param = isset($_REQUEST ['callback_param']) ? $_REQUEST ['callback_param'] : false ;
$callback = isset($_REQUEST ['callback_function']) ? $_REQUEST ['callback_function'] : false ;
cors(); // cors
echo sendResult($cursor,$callback,$view_fields_permitions,$callback_param,$view_fields_type);

?>
